#include <iostream>
#include <string>

using namespace std;

string solve() {
  // used to store the numeric value of a digit (index with a character)
  int sval[256];

  string anum, slang, tlang;

  cin >> anum >> slang >> tlang;

  // sval[c] is the valid of digit c in the source language
  for (int i = 0; i < slang.length(); ++i)
    sval[slang[i]] = i; // the value of the i'th character in the source language is i

  // convert the number "anum" to the actual integer value it represents
  // the bounds in the problem statement guarantee no overflow
  int num = 0, base1 = slang.size();
  for (int i = 0; i < anum.size(); ++i)
    num = num*base1 + sval[anum[i]];

  // now we are storing the actual number, next we convert it to the target language

  string ans = "";
  int base2 = tlang.size();
  while (num > 0) {
    // num%base2 is the next digit, we just have to get the actual character
    // in the target language for the next digit
    ans = tlang[num%base2] + ans; // remember here + means string concatenation
    num /= base2;
  }

  // this only happens if num was 0 to begin with
  if (ans.length() == 0)
    ans += tlang[0];

  return ans;
}

int main() {
  int n;
  cin >> n;

  for (int cno = 1; cno <= n; ++cno)
    cout << "Case #" << cno << ": " << solve() << endl;

  return 0;
}
